

//
//
// Countdown 
// © Oscar Zander, www.time55.com
//
//




// Datumet och tiden som nedräkningen går till. ("Standard" är år 3000.)
var countdown_to_year = "3000"; 
var countdown_to_month = "1";
var countdown_to_day = "1";
var countdown_to_hour = "0";
var countdown_to_minute = "0";
var countdown_to_second = "0"; 

// Tar fram arrayen med antalet år, dagar, timmar, minuter och
// sekunder som är kvar till målet. 
var time_left = getTimeLeftArray(countdown_to_year, countdown_to_month, 
countdown_to_day, countdown_to_hour, countdown_to_minute, countdown_to_second);
var year_left = time_left[0]; 
var day_left = time_left[1]; 
var hour_left = time_left[2]; 
var minute_left = time_left[3];
var second_left = time_left[4];


// Anger att nedräkningen inte skall startas från början. 
var start_countdown = true; 



// Bestämmer till vilket datum och till vilken tid nedräkningen skall gå.
function setTime(to_year, to_month, to_day, to_hour, to_minute, to_second)
{
	// Lagrar tiden som nedräkningen går till i "fält". 
	countdown_to_year = to_year; 
	countdown_to_month = to_month; 
	countdown_to_day = to_day; 
	countdown_to_hour = to_hour; 
	countdown_to_minute = to_minute; 
	countdown_to_second = to_second; 
	

	// Minskar månadens nummer med 1, så att januari får nummer 0, februari 
	// nummer 1, mars nummer 2, osv.
	to_month = to_month - 1;
	
	
	// Året, månaden, dagen, timmen och minuten som nedräkningen går till.
	// (Tar först bort eller lägger till tid p.g.a sommartiden.)
	var daylight_saving_time_array = 
	daylightSavingTime(to_year, to_month, to_day, to_hour, to_minute, to_second);
	
	var new_countdown_to_year = daylight_saving_time_array[0]; 
	var new_countdown_to_month = daylight_saving_time_array[1];
	var new_countdown_to_day = daylight_saving_time_array[2];
	var new_countdown_to_hour = daylight_saving_time_array[3];
	var new_countdown_to_minute = daylight_saving_time_array[4];
	var new_countdown_to_second = daylight_saving_time_array[5];
	
	
	// Tar fram tiden som är kvar till målet. 
	time_left = getTimeLeftArray(new_countdown_to_year, new_countdown_to_month, 
	new_countdown_to_day, new_countdown_to_hour, 
	new_countdown_to_minute, new_countdown_to_second); 
	year_left = time_left[0]; 
	day_left = time_left[1]; 
	hour_left = time_left[2]; 
	minute_left = time_left[3];
	second_left = time_left[4];
	
	
	// Kontrollerar om ett byte till / från sommartid sker inom en snart framtid, 
	// och ändrar sedan då isåfall tiden som är kvar till målet.
	check_time_change(to_year, to_month, to_day, to_hour, to_minute, to_second);
}




// Lägger till / tar bort tid p.g.a sommartiden.  
function daylightSavingTime(to_year, to_month, to_day, to_hour, to_minute, to_second)
{
	// Tar fram tidsskillnaden mellan dagens datum och UTC (GMT).
	var today = new Date(); 
	var time_difference_today = today.getTimezoneOffset(); 
	
	// Tidskillnaden mellan datumet som nedräkningen går till och UTC (GMT). 
	var countdown_to_date = new Date(); 
	countdown_to_date.setFullYear(to_year, to_month, to_day); 
	countdown_to_date.setHours(to_hour, to_minute, to_second, 0);
	var time_difference_countdown_to_date = 
  countdown_to_date.getTimezoneOffset();
	
	// Tidsskillnaden (i MINUTER) mellan dagens datum, 
	// och datumet som nedräkningen går till. 
	var total_time_difference_minutes = time_difference_today - 
	time_difference_countdown_to_date; 

    // Tidsskillnaden (i MILLISEKUNDER) mellan dagens datum,
    // och datumet som nedräkningen går till. 
	var total_time_difference_milli = 
	total_time_difference_minutes * 60 * 1000;
	
	
	
	// "Gör om" countdown_to_date till millisekunder. 
	var countdown_to_date_milli = Date.parse(countdown_to_date); 
	// Lägger till tidsskillnaden. 
	countdown_to_date_milli = countdown_to_date_milli + 
  total_time_difference_milli; 
	
	// Tar fram "det nya" datumet som nedräkningen går till 
	// (med tidsskillnaden inräknad).
	var new_countdown_to_date = new Date(countdown_to_date_milli); 

	// Skapar en array med tiden som är kvar (tiddskillnaden inräknad). 
	var daylight_saving_time_array = new Array();
	daylight_saving_time_array[0] = new_countdown_to_date.getFullYear();
	daylight_saving_time_array[1] = new_countdown_to_date.getMonth();
	daylight_saving_time_array[2] = new_countdown_to_date.getDate();
	daylight_saving_time_array[3] = new_countdown_to_date.getHours();
	daylight_saving_time_array[4] = new_countdown_to_date.getMinutes();
	daylight_saving_time_array[5] = new_countdown_to_date.getSeconds();

	
	// Returnerar arrayen daylight_saving_time.
	return daylight_saving_time_array;
}



// Kontrollerar om ett byte till/från sommartid sker inom en snar framtid, 
// och anpassar då tiden så att en timme kommer att läggas till / tas bort. 
// (Kan vara två timmar, om ett visst land har två timmars sommartid.)
function check_time_change(to_year, to_month, to_day,
to_hour, to_minute, to_second)
{
	// Tar fram tidsskillnaden för dagens datum (Jämfört med UTC (GMT)).
	var today = new Date(); 
	var time_difference_today = today.getTimezoneOffset();
	
	// Antalet timmar + minuter + sekunder tillsammas som är kvar, 
	// omvandlat till millisekunder ("Tiden, som inte ingår i hela dagar"). 
	var hours_minutes_seconds_in_mill = 
	hour_left * 60 * 60 * 1000 + minute_left * 60 * 1000 + second_left * 1000; 
	
	// Tar fram tidsskillnaden för "det nya datumet". (Jämfört med UTC (GMT)).
	var new_today = new Date(Date.parse(today) + 
	hours_minutes_seconds_in_mill); 
	var time_difference_new_today = new_today.getTimezoneOffset();
	
	// Tar fram tidsskillnaden mellan today och new_today ("det nya datumet"). 
	var total_time_difference_minutes = time_difference_new_today - 
	time_difference_today;


	// Ändrar minute_left.
	minute_left = minute_left + total_time_difference_minutes; 
	
	// Ser till att extra minuter läggs till / tas bort. 
	// (Kommer även att lägga till / ta bort timmar.
	while(minute_left >= 60)  {
		minute_left = minute_left - 60;
		hour_left = hour_left + 1;
	}
	
	while(minute_left < 0)  {
		minute_left = minute_left + 60;
		hour_left = hour_left - 1;
	}

	// Kontrollerar att inte antalet timmar har blivit negativt.
	while(hour_left < 0)  {
		hour_left = hour_left + 24;
		day_left = day_left - 1;
	}
	
	// Kontrollerar att antalet dagar inte har blivit negativt. 
	// (Om antalet dagar har blivit negativt, så minskas antalet år med 1.
	// Det kontrolleras då också om en skottdag infaller inom en viss tid.) 
	if(day_left < 0)  {
		day_left = 365 + day_left; 
		year_left = year_left - 1;
	
		// Antalet dagar kvar att kontrollera.
		var days_left_to_check = day_left;
	
		// Går igenom alla "överbilva dagar" 
    // (de dagar som inte räknas till något år), 
		// och ser om en skottdag hittas bland dessa. 
		while(days_left_to_check >= -2)  {
			var today_milli_seconds = Date.parse(today);  
			// Kontrollerar om en skottdag har hittats.
			if(new Date(today_milli_seconds).getMonth() == 1
			&& new Date(today_milli_seconds).getDate() == 29)  {
				// En skottdag har hittats.
				day_left = day_left + 1;

			}
		// "Går fram" en dag, och kontrollerar den.
		today = new Date(today_milli_seconds + (1000 * 60 * 60 * 24));
		// Minskar antalet dagar som skall kontrolleras med 1.
		days_left_to_check--;
	
		}
	
	}

}

// Startar nedräkningen.
function startCountdown() 
{
    start_countdown = true;
}

// Stoppar nedräkningen. 
function stopCountdown()
{
    start_countdown = false;
}




// Beräknar tiden som är kvar till målet, och skriver ut den. 
function countdown()
{ 
	second_left = second_left - 1;
	// Om antalet sekunder blivit negativt, så tas tiden fram igen. 
	if(second_left < 0)  {
		setTime(countdown_to_year, countdown_to_month, countdown_to_day, 
		countdown_to_hour, countdown_to_minute, countdown_to_second)
	}
		
	// Skriver ut tiden, och väntar sedan i 1 sekund. 
	writeTime(year_left, day_left, hour_left, minute_left, second_left); 
	// Forsätter att skriva ut tiden (om inte nedräkningen skall stoppas.)
	if(start_countdown == true)  {
	   setTimeout("countdown()",1000);
  }
}







// Skriver ut antalet år, dagar, timmar, minuter 
// och sekunder som är kvar till målet.
function writeTime(year_left, day_left, hour_left, minute_left, second_left)  
{
var time_left_string_array = getOutStringArray(year_left, day_left,
hour_left, minute_left, second_left);

// Tar fram tiden som är kvar (med text, som t.ex minut, sekunder)
var year_string = time_left_string_array[0]; 
var day_string = time_left_string_array[1]; 
var hour_string = time_left_string_array[2]; 
var minute_string = time_left_string_array[3];
var second_string = time_left_string_array[4];
 
	// Skriver ut tiden som är kvar.
	document.getElementById("years").innerHTML = "" + year_string;
	document.getElementById("days").innerHTML = "" + day_string;
	document.getElementById("hours").innerHTML = "" + hour_string;
	document.getElementById("minutes").innerHTML = "" + minute_string;
	document.getElementById("seconds").innerHTML = "" + second_string;
}








// Returnerar en array med tiden som är kvar till målet. 
function getTimeLeftArray(year, month, day, hour, minute, second)
{	
	// Totala tiden som är kvar (i sekunder), här kommer
	// sedan "överblivna" sekunder att lagras. 
	var time_store = timeInSeconds(year, month, day, hour, minute, second); 

	// Antalet sekunder som är kvar. 
	second_left = time_store % 60; 
	// Tar bort antalet sekunder som är kvar, samt delar time_store med
	// 60, så att time_store innehåller tiden som är kvar till målet i minuter.
	time_store = time_store - second_left;
	time_store = time_store / 60;
	
	// Samma sak med minuter, timmar och dagar. 
	minute_left = time_store % 60; 
	time_store = time_store - minute_left;
	time_store = time_store / 60; 
	
	hour_left = time_store % 24; 
	time_store = time_store - hour_left;
	time_store = time_store / 24;
	
	day_left = time_store % 365; 
	time_store = time_store - day_left;
	time_store = time_store / 365;
	
	
	

	
	// SKOTTDAGAR...
	
	// Dagens datum. (Används även längre ner.)
	var today = new Date();
	
	var current_year = today.getFullYear();  
	// Går igenom alla år mellan det nuvarande året, och året som nedräkningen 
	// går till, och drar ifrån dagar om ett skottår har hittatas. 
		while(current_year <= year)  {
		if(isLeapYear(current_year) == true)  {
			day_left = day_left - 1; 
		}
		current_year++;
	    }
		
	
	
		
	// Lägger till en dag om skottdagen för det nuvarande året inte 
	// skall tas bort, dvs. om det är mars, april, maj, ...
	if(isLeapYear(today.getFullYear()) == true)  {
		if(today.getMonth() > 1)  {
			day_left = day_left + 1;
		}
		else  {}
	}
	
	// Lägger till en dag om skottdagen för året som nedräkningen går till skall
	// tas bort, dvs. om nedräkningen går till januari eller februari (ej feb 29).
	if(isLeapYear(year) == true)  {
		if(month == 0)  {
			day_left = day_left + 1;
		}
		else if(month == 1 && day <= 28)  {
			day_left = day_left + 1;
		}
		else  {}
	}
	
	


	// Kontrollerar om day_left har bilvit negativ, och ändrar det då, 
	// så att ett år dras ifrån och "de negativa dagarna"
  //  blir en ny del av ett år.
	year_left = 0;
	if(day_left < 0)  {
	    day_left = 365 + day_left;
		year_left = - 1;
	}
	else {}
	
	
	// Antalet dagar kvar att kontrollera.
	var days_left_to_check = day_left;
	// En skottdag har inte lagts till.
	var leap_day_added = false;

	
	// Om det är februari (inte 29:e februari), så kommer inte lika många 
	// dagar att kontrolleras. Anledningen till detta är att den 29:e 
	// februari inte skall "kontrolleras av misstag".
	if(month == 1 && day <= 28)  {
	number_days = 0;
	}
	else  {
	number_days = -2;
	}
	
	// Går igenom alla "överbilva dagar" (de dagar som inte räknas till något år), 
	// och ser om en skottdag hittas bland dessa. 
	while(days_left_to_check >= number_days)  {
  
		// Kontrollerar om en skottdag har hittats.
		if(today.getMonth() == 1
		&& today.getDate() == 29)  {
			// En skottdag har hittats.
			 day_left = day_left + 1;
			 leap_day_added = true;
		}			

		// "Går fram" en dag, och kontrollerar den.
		today = new Date(Date.parse(today) + (1000 * 60 * 60 * 24));
  
		
		// Minskar antalet dagar som skall kontrolleras med 1.
		days_left_to_check--;
	
	}
	

	
// OLIKA SPECIALFALL.

	// Specialfall, om det är den 28:e februari, och nedräkningen 
	// går till den 29:e februari.
	if(new Date().getMonth() == 1 && new Date().getDate() == 28 
	&& month == 1 && day == 29)  {
		
		if(day_left >= 365)  {
			day_left = day_left - 365;
			year_left = year_left + 1;
		}
	}
		
	// Specialfall, om nedräkningen går till den 29:e februari, 
	// och det inte är skottår, och ingen skottdag har lagts till.
	if(month == 1 && day == 29 && leap_day_added == false)  {
		day_left = day_left + 1;
		if(day_left == 365 && new Date().getMonth() !=2 )  {
			day_left = 0; 
			year_left = year_left + 1; 
		}
	}
	
	// Specialfall, om det är en skottdag,
	// och nedräkningen går till en skottdag.
	if(month == 1 && day == 29 && 
	new Date().getMonth() == 1 && new Date().getDate() == 29)  {
		day_left = day_left + 1;
		if(day_left == 366)  {
			day_left = 0;
			year_left = year_left + 1;
		}
	}
	
	// Specialfall, om det är den 29:e februari, och nedräkningen 
	// går till den 1:e mars.
	if(new Date().getMonth() == 1 && new Date().getDate() == 29 
	&& month == 2 && day == 1)  {
		day_left = day_left - 1;
		if(day_left == 364)  {
			day_left = 0;
			year_left = year_left + 1;
		} 
		else  {
			day_left = day_left + 1;
		}
	}

			
	
	
		
	
	// Antalet år som är kvar (kan vara ett mindre än time_store, om ett år
	// tidigare har dragits ifrån p.g.a "skottdagar". 
	var year_left = year_left + time_store;
	
	
	

	
	
	// Returnerar en array med antalet år, dagar, timmar, minuter 
	// och sekunder kvar till målet.
	var time_left = new Array();
	time_left[0] = year_left;
	time_left[1] = day_left;
	time_left[2] = hour_left;
	time_left[3] = minute_left;
	time_left[4] = second_left;
	return time_left;
}







// Testar om ett visst år är skottår. 
// Ett år är skottår om det är jämnt delbart med 4.
// Undantag är år som är delbara med 100, men inte jämnt delbara med 400.
function isLeapYear(year)
{
	var leap_year = false; 
	
	if(year % 4 == 0)  {
		leap_year = true; 
	}
	
	if((year % 100 == 0) && (year % 400 > 0))  {
		leap_year = false; 
	}
	
	// Returnerar om året är ett skottår (true eller false).
	return leap_year; 
}








// Tar fram tiden (i sekunder), som är kvar till målet.  
function timeInSeconds(year, month, day, hour, minute, second)
{
	// Dagens datum och tid. 
	var today = new Date(); 
	// Antalet millisekunder som gått från år 1970 till dagens datum. 
	var milli_seconds_since_1970 = Date.parse(today); 

	// Datumet, som nedräkningen går till.
	var countdown_to_date = new Date(); 
	countdown_to_date.setFullYear(year, month, day); 
	countdown_to_date.setHours(hour,minute,second,0);

	// Tiden som är kvar (i millisekunder).
	var time_left_milli = 
  Date.parse(countdown_to_date) - milli_seconds_since_1970;
	// Tiden som är kvar (i sekunder). 
	var time_left_sec = (time_left_milli) / 1000; 

	// Returnerar tiden (i sekunder) som är kvar. 
	return time_left_sec;
}




